# -*- coding: iso-8859-15 -*-
from visual import *
from visual.text import *
import povexport
from math import pi
from text3D import text3D

scene.x=scene.y=0
scene.up = (0,1,0)
scene.forward = (0,0,-1)
scene.width=1024
scene.height=768
scene.foreground=color.black
scene.background=color.white
light1 = (0.17, 0.35, 0.70) # mag=0.8
light2 = (-0.26, -0.07, -0.13) # mag=0.3
light1 = vector(light1).mag*vector(1, 1, 1) .norm()
scene.lights = [light1, light2]

def pov(filename):
    """ Export the scene as pov file.
    """
    scene.mouse.getclick()
    povexport.export(filename = filename)

c_ = arrow(pos= (0,0,0), axis=(0,1,0), fixedwidth = 1, shaftwidth = 0.03)
text3D(pos=c_.axis+vector(0.1,0,0), string='c*', justify='center', color=color.black, axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.03)

b= arrow(pos= (0,0,0), axis=(3,0,0), fixedwidth = 1, shaftwidth = 0.03)
text3D(pos=b.axis+vector(0.1,0,0), string='b', justify='center', color=color.black, axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.03)

a_ = arrow(pos= (0,0,0), axis=(0,0,3), fixedwidth = 1, shaftwidth = 0.03)
text3D(pos=a_.axis+vector(0,0.1,0), string='a*', justify='center', color=color.black, axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.03)

# box(pos= (0,1,0), height=5, width=0.005, length=5, color=(1/3.,1,1), transparency = 0.5)
# box(pos= (0,0,), height=0.005, width=5, length=4, color=(1/3.,1.,1),  transparency=0.5)

Mv=2*vector(3,1.5,2).norm()
M = arrow(pos= (0,0,0), axis=Mv, fixedwidth = 1, shaftwidth = 0.03, color=color.red)
text3D(pos=M.axis+vector(0,0.1,-0.1), string='m', justify='center', color=color.red, axis=(1,0,-1), up=(0,1,0), height=0.3,depth=0.03)

Mab=vector(Mv.x, 0, Mv.z)
M = arrow(pos=(0,0,0), axis=Mab, fixedwidth = 1, shaftwidth = 0.03, color=(0.5, 0.5, 0.5))
M = cylinder(pos= Mv, axis=Mab-Mv, radius = 0.005, color=(0.5, 0.5, 0.5))

Mc=vector(0, Mv.y, 0)
M = arrow(pos=(0,0,0), axis=Mc, fixedwidth = 1, shaftwidth = 0.03, color=(0.5, 0.5, 0.5))
M = cylinder(pos= Mv, axis=Mc-Mv, radius = 0.005, color=(0.5, 0.5, 0.5))


beta = cylinder(pos=Mab/3., axis = (Mv-Mab)/3., radius = 0.01, color=color.red)
phi = cylinder(pos = Mab/2., axis =(b.axis/3.-Mab/2.), radius = 0.01, color=color.red)
text3D(pos=beta.pos + beta.axis/2 + vector(0.3, 0, 0.3), string='b', justify='center', color=color.red, axis=(1,0,-1), up=(0,1,0), height=0.3,depth=0.03)
text3D(pos=phi.pos + phi.pos/2+ vector(0, 0.2, -0.3), string='j', justify='center', color=color.red, axis=(1,0,-1), up=(0,1,0), height=0.3,depth=0.03)


pov('Canting.pov')