from visual import *
from visual.text import *
import povexport
from math import pi
from text3D import text3D

scene.x=scene.y=0
scene.up = (0,1,0)
scene.forward = (0,0,-1)
scene.width=1024
scene.height=768
scene.foreground=color.black
scene.background=color.white
light1 = (0.17, 0.35, 0.70) # mag=0.8
light2 = (-0.26, -0.07, -0.13) # mag=0.3
light1 = vector(light1).mag*vector(1, 1, 1) .norm()
scene.lights = [light1, light2]

def pov(filename):
    """ Export the scene as pov file.
    """
    scene.mouse.getclick()
    povexport.export(filename = filename)
    
b = arrow(pos=(0,0,0), axis=(0,2,0), fixedwidth = 1, shaftwidth = 0.03)
text3D(pos=b.axis+vector(0.2,0,0), string='b', justify='center', color=color.black, axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.03)

a_ = arrow(pos=(0,0,0), axis=(3,0,0), fixedwidth = 1, shaftwidth = 0.03, color=color.black)
text3D(pos=a_.axis+vector(0.3,0,0), string='a*', justify='center', color=color.black, axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.03)

c_ = arrow(pos=(0,0,0), axis=(0,0,2), fixedwidth = 1, shaftwidth = 0.03, color=color.black)
text3D(pos=c_.axis+vector(0,0,0.3), string='c*', justify='center', color=color.black, axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.03)

box(pos= (0,0,), height=0.005, width=3, length=4, color=(1,1/3.,1),  transparency=0.5)

Qv=2*vector(3,0,1).norm()

Qperp = box(pos=(0,0,0), height=2, width=0.005, length=2, color=(1/3.,1,1), transparency = 0.5)
myAngle = c_.axis.diff_angle(Qv)
Qperp.rotate(axis=(0,1,0), angle = myAngle)

Q = arrow(pos= (0,0,0), axis=Qv, fixedwidth = 1, shaftwidth = 0.02, color=color.red)
text3D(pos=Q.axis+vector(0,0.1,-0.1), string='Q', justify='center', color=color.red, axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.03)

X = arrow(pos= (0,0,0), axis=1*Q.axis.norm(), fixedwidth = 1, shaftwidth = 0.03, color=color.blue)
text3D(pos=X.axis+vector(-0.3,0,0), string='X', justify='center', color=color.blue, axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.03)

Z = arrow(pos= (0,0,0), axis=1*b.axis.norm(), fixedwidth = 1, shaftwidth = 0.03, color=color.blue)
text3D(pos=Z.axis+vector(0,0,0.3), string='Z', justify='center', color=color.blue, axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.03)

Y = arrow(pos= (0,0,0), axis=1*(Z.axis.cross(X.axis)).norm(), fixedwidth = 1, shaftwidth = 0.03, color=color.blue)
text3D(pos=Y.axis+vector(0.3,0.3,0), string='Y', justify='center', color=color.blue, axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.03)

pov('QXYZ.pov')
