from visual import *
from visual.text import *
import povexport
from math import pi
from text3D import text3D

scene.x=scene.y=0
scene.up = (0,1,0)
scene.forward = (0,0,-1)
scene.width=1024
scene.height=768
scene.foreground=color.black
scene.background=color.white
light1 = (0.17, 0.35, 0.70) # mag=0.8
light2 = (-0.26, -0.07, -0.13) # mag=0.3
light1 = vector(light1).mag*vector(1, 1, 1) .norm()
scene.lights = [light1, light2]

def pov(filename):
    """ Export the scene as pov file.
    """
    scene.mouse.getclick()
    povexport.export(filename = filename)
    
a = arrow(pos= (0,0,0), axis=(2,0,0), fixedwidth = 1, shaftwidth = 0.1)
a.rotate(angle=-pi/6, axis=(0,0,1))
text3D(pos=a.axis+vector(0.3,-0.3,0.3), string='a', justify='center', color=color.black, axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.03)

b = arrow(pos= (0,0,0), axis=(0,2,0), fixedwidth = 1, shaftwidth = 0.11)
text3D(pos=b.axis+vector(0,0,0.5), string='b', justify='center', color=color.black, axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.03)

c = arrow(pos= (0,0,0), axis=(0,0,4), fixedwidth = 1, shaftwidth = 0.1)
text3D(pos=c.axis+vector(0,0,0.3), string='c', justify='center', color=color.black, axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.03)

a_ = arrow(pos= (0,0,0), axis=(3,0,0), fixedwidth = 1, shaftwidth = 0.1, color=(0.5,0.5,0.5))
text3D(pos=a_.axis+vector(0.3,0,0), string='a*', justify='center', color=(0.5,0.5,0.5), axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.03)

b_ = arrow(pos= (0,0,0), axis=(0,3,0), fixedwidth = 1, shaftwidth = 0.1, color=(0.5,0.5,0.5))
b_.rotate(angle=-pi/6, axis=(0,0,1))
text3D(pos=b_.axis+vector(0,0,0.3), string='b*', justify='center', color=(0.5,0.5,0.5), axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.03)

c_ = arrow(pos= (0,0,0), axis=(0,0,3), fixedwidth = 1, shaftwidth = 0.11, color=(0.5,0.5,0.5))
text3D(pos=c_.axis+vector(0,0.3,0.3), string='c*', justify='center', color=(0.5,0.5,0.5), axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.03)

box(pos= (0,1,0), height=5, width=0.005, length=5, color=(1,1/3.,1), transparency = 0.5)
box(pos= (0,0,), height=0.005, width=5, length=4, color=(1/3.,1,1),  transparency=0.5)

Qv=2*vector(2,0,3).norm()

Q = arrow(pos= (0,0,0), axis=Qv, fixedwidth = 1, shaftwidth = 0.11, color=color.red)
text3D(pos=Q.axis+vector(0,0.3,0.3), string='Q', justify='center', color=color.red, axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.03)

X = arrow(pos= (0,0,0), axis=3*Q.axis.norm(), fixedwidth = 1, shaftwidth = 0.1, color=color.blue)
text3D(pos=X.axis+vector(0,0.3,0.3), string='x', justify='center', color=color.blue, axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.03)

Z = arrow(pos= (0,0,0), axis=3*b.axis.norm(), fixedwidth = 1, shaftwidth = 0.1, color=color.blue)
text3D(pos=Z.axis+vector(0.3,0,0.3), string='z', justify='center', color=color.blue, axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.03)

Y = arrow(pos= (0,0,0), axis=3*(Z.axis.cross(X.axis)).norm(), fixedwidth = 1, shaftwidth = 0.1, color=color.blue)
text3D(pos=Y.axis+vector(0,0.3,0), string='y', justify='center', color=color.blue, axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.03)

pov('Reperes.pov')
