# -*- coding: iso-8859-15 -*-
from visual import *
from visual.text import *
import povexport
from math import pi
from text3D import text3D

scene.x=scene.y=0
scene.up = (0,1,0)
scene.forward = (0,0,-1)
scene.width=1024
scene.height=768
# scene.fov = pi/180
scene.foreground=color.black
scene.background=color.white
light1 = (0.17, 0.35, 0.70) # mag=0.8
light2 = (-0.26, -0.07, -0.13) # mag=0.3
light1 = vector(light1).mag*vector(1, 1, 1) .norm()
scene.lights = [light1, light2]

def pov(filename):
    """ Export the scene as pov file.
    """
    scene.mouse.getclick()
    povexport.export(filename = filename)

c_ = arrow(pos= (0,0,0), axis=(0,1.5,0), fixedwidth = 1, shaftwidth = 0.05)
text3D(pos=c_.axis+vector(0.1,0,0), string='w', justify='center', color=color.black, axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.03)

b= arrow(pos= (0,0,0), axis=(1.5,0,0), fixedwidth = 1, shaftwidth = 0.05)
text3D(pos=b.axis+vector(0.1,-0.1,0), string='v', justify='center', color=color.black, axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.03)

a_ = arrow(pos= (0,0,0), axis=(0,0,1.5), fixedwidth = 1, shaftwidth = 0.05)
text3D(pos=a_.axis+vector(-0.5,0.1,0), string="u=u'", justify='center', color=color.black, axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.05)

Mv=vector(1, 0., 0.)
M = arrow(pos= (0,0,0), axis=Mv, fixedwidth = 1, shaftwidth = 0.05, color=color.red)
M.rotate(axis=(0, 0, 1), angle=pi/10)
text3D(pos=M.axis+vector(0,0.1,0.1), string="v'", justify='center', color=color.red, axis=(1,0,-1), up=(0,1,0), height=0.3,depth=0.03)

beta = cylinder(pos= M.axis.norm(), axis=b.axis.norm()-M.axis.norm(), color=color.blue, radius = 0.005)
text3D(pos=beta.pos+vector(0.2,-0.1,0.1), string='b', justify='center', color=color.blue, axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.05)

plan = box(pos= (0,0,0), height=2, width=0.005, length=2, color=(1/3.,1.,1),  transparency=0.5)
plan1 = box(pos= (0,0,0), height=0.005, width=2, length=2, color=(1,1/3.,1),  transparency=0.5)
# plan.rotate(axis=(0, 0, 1), angle=pi/10)

pov('beta.pov')