from visual import *
from visual.text import *
import povexport
from text3D import text3D

scene.x=scene.y=0
scene.up = (0,1,0)
scene.forward = (0,0,-1)
scene.width=1024
scene.height=768
scene.foreground=color.black
scene.background=color.white
light1 = (0.17, 0.35, 0.70) # mag=0.8
light2 = (-0.26, -0.07, -0.13) # mag=0.3
light1 = vector(light1).mag*vector(1, 1, 1) .norm()
scene.lights = [light1, light2]

def pov(filename = 'RegleSelection.pov'):
    """ Export the scene as pov file.
    """
    scene.mouse.getclick()
    povexport.export(filename = filename)
    
arrow(pos= (0,0,0), axis=(3,0,0), fixedwidth = 1, shaftwidth = 0.03)
text3D(pos=(3+0.3,0,0), string='X', justify='center', color=color.black, axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.03)

arrow(pos= (0,0,0), axis=(0,3,0), fixedwidth = 1, shaftwidth = 0.03)
text3D(pos=(0,3+0.3,0), string='Z', justify='center', color=color.black, axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.03)

arrow(pos= (0,0,0), axis=(0,0,-3), fixedwidth = 1, shaftwidth = 0.03)
text3D(pos=(0,0,-3-0.3), string='Y', justify='center', color=color.black, axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.03)

box(pos= (0,1,-1), height=2, width=2, length=0.005, color=(1/3.,1,1), transparency = 0.5)

Q=vector(2,0,0)
M=vector(1.2,1.5,-0.8)

arrow(pos= (0,0,0), axis=Q, fixedwidth = 1, shaftwidth = 0.06, color=color.red)
text3D(pos=(2,0.1,-0.1), string='Q', justify='center', color=color.red, axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.03)

arrow(pos= (0,0,0), axis=M, fixedwidth = 1, shaftwidth = 0.06, color=color.blue)
text3D(pos=M+vector(0,0.1,-0.1), string='M', justify='center', color=color.blue, axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.03)

cylinder(pos= (0,0,M.z), axis=(0,M.y,0), color=color.blue, radius = 0.015)
cylinder(pos= (0,M.y,0), axis=(0,0,M.z), color=color.blue, radius = 0.015)
cylinder(pos= (0,M.y,M.z), axis=(M.x,0,0), color=color.blue, radius = 0.015)

Mperp = vector(0,M.y,M.z)
arrow(pos= (0,0,0), axis=Mperp, fixedwidth = 1, shaftwidth = 0.04, color=color.blue)
text3D(pos=Mperp+vector(0.1,0.3,0.3), string='M', justify='center', color=color.blue, axis=(1,0,-1), up=(0,1,0), height=0.3, depth=0.03)
# cylinder(pos= Mperp+vector(0.1,0.3,0.3)+vector(0,0,-0.25), axis=(0.1,0.0,-0.10), color=color.blue, radius = 0.015)
# cylinder(pos= Mperp+vector(0.1,0.3,0.3)+vector(0,0,-0.3), axis=(0,0.1,0.0), color=color.blue, radius = 0.015)

pov()
